﻿<div class="jumbotron">
    <h1>Game Sharing</h1>
    <p class="lead">Share games with other users</p>
</div>
<div class="row">
    <div class="col-md-4">
        <label>User: <select id="userReturn"></select></label><br />
        <label>Borrowed Game: <select id="borrowedGames"></select></label><br />
        <input type="submit" id="returnVideoGame" value="Return Borrowed Game" /><br />
    </div>
    <div class="col-md-4">
        <label>User Borrowing: <select id="userBorrowing"></select></label><br />
        <label>User Borrowing From: <select id="userBorrowingFrom"></select></label><br />
        <label>Available Games: <select id="availableGames"></select></label><br />
        <input type="submit" id="borrowVideoGame" value="Borrow Game" /><br />
    </div>
    <script>

        (function () {
            //Robbie Mattson web services final project
            var borrowedGamesByUser;
            var borGamesForUser;
            var avGamesForUser;
            var gamesAvailableByUser;
            var returningUser;
            var gamesBorrowedByUser;
            var returningUserSelect = $("#userReturn");
            var usBorrowingSelect = $("#userBorrowing");
            var usBorrowingFromSelect = $("#userBorrowingFrom");
            var gamesBorrowed = $("#borrowedGames");
            var gamesAvailable = $("#availableGames");
            var vidGames = [];
            
            getUsers(fillUserLists);
            getVideoGames();
            getGamesBorrowedByUser(1, fillGamesToReturnList);
           
            getGamesAvailableByUser(1, fillAvailableGamesList);
            

            //$("#formAddVideoGame").off("submit");
            $("#returnVideoGame").on("click", processReturnGame);
            $("#borrowVideoGame").on("click", processBorrowGame);

            function getUsers(callBackWhenDone) {
                //uses user array in closure variable
                us = "loading";

                var jqxhr = $.getJSON("/api/user/", function (data) {
                    console.log("success");
                    us = data;
                    callBackWhenDone();
                })
                    .done(function () {
                        console.log("second success");
                    })
                    .fail(function () {
                        console.log("error");
                    })
                    .always(function () {
                        console.log("complete");
                    });
            }

            //returns game to owner after user clicks return game handler
            function processReturnGame() {
                // uses selectedVideoGame videogame in closure variable
                var vidId = $("#borrowedGames option:selected").attr("id").substring(5);
                //alert(vidId);
                selectedVideoGame = "none";
                $.each(vidGames, function (g, game) {
                    if (game.VideoGameId == vidId) {
                        selectedVideoGame = game;
                    }
                });

                $.ajax({
                    contentType: 'application/json',
                    url: "/api/videogame/" + selectedVideoGame.VideoGameId + "/return/",
                    type: 'PUT',
                    data: JSON.stringify(selectedVideoGame),
                    success: function (result) {
                        //alert("success?");
                    },
                    error: (function (xhr) {
                        console.log("error: " + xhr.status);
                        alert("failure: " + xhr.status);
                    })
                });

                return false; // stop form submit
            }

            //Borrows game from owner after user clicks borrowed game
            function processBorrowGame() {
                // uses selectedVideoGame videogame in closure variable
                var vidId = $("#availableGames option:selected").attr("id").substring(5);
                var usId = $("#userBorrowing option:selected").attr("id").substring(12);
                //alert(vidId);
                //alert(usId);
                selectedVideoGame = "none";
                
                $.each(gamesAvailableByUser, function (g, game) {
                    if (game.VideoGameId == vidId) {
                        selectedVideoGame = game;
                    }
                });

                $.ajax({
                    contentType: 'application/json',
                    url: "/api/videogame/" + selectedVideoGame.VideoGameId + "/borrow/" + usId,
                    type: 'PUT',
                    data: JSON.stringify(selectedVideoGame),
                    success: function (result) {
                        //alert("success?");
                    },
                    error: (function (xhr) {
                        console.log("error: " + xhr.status);
                        alert("failure: " + xhr.status);
                    })
                });

                return false; // stop form submit
            }

            //function that gets games that are borrowed by selected user
            function getGamesBorrowedByUser(uId, callBackWhenDone) {
                gamesBorrowedByUser = "loading";
                var jqxhr = $.getJSON("/api/user/" + uId + "/borrowedgames", function (data) {
                    console.log("success");
                    //alert(data);
                    borrowedGamesByUser = data;
                    callBackWhenDone();
                })
                    .done(function () {
                        console.log("second success");
                    })
                    .fail(function () {
                        console.log("error");
                    })
                    .always(function () {
                        console.log("complete");
                    });
            }

            //gets all videogames
            function getVideoGames() {
                vidGames = "loading";
                var jqxhr = $.getJSON("/api/Videogame", function (data) {
                    console.log("success");
                    //alert(JSON.stringify(data));
                    vidGames = data;
                })
                    //vidGames
                    .done(function () {
                        console.log("second success");
                    })
                    .fail(function () {
                        console.log("error");
                    })
                    .always(function () {
                        console.log("complete");
                    });
            }

            //gets games borrowed by selected user
            function getBorrowedGamesByUser() {
                borrowedGamesByUser = "loading";
                var uId = $("#userReturn option:selected").attr("id").substring(5);
                var jqxhr = $.getJSON("/api/user/" + uId + "/borrowedgames", function (data) {
                    console.log("success");
                    
                    borrowedGamesByUser = data;
                    //alert(JSON.stringify(borrowedGamesByUser));
                    fillGamesToReturnList();

                })
                    .done(function () {
                        console.log("second success");
                    })
                    .fail(function () {
                        console.log("error");
                    })
                    .always(function () {
                        console.log("complete");
                    });
            }

            //gets games that are available to borrow by owner
            function getGamesAvailableByUser(uId, callBackWhenDone) {
                gamesAvailableByUser = "loading";
                var jqxhr = $.getJSON("/api/user/" + uId + "/availablegames", function (data) {
                    console.log("success");
                    //alert(data);
                    gamesAvailableByUser = data;
                    callBackWhenDone();
                })
                    .done(function () {
                        console.log("second success");
                    })
                    .fail(function () {
                        console.log("error");
                    })
                    .always(function () {
                        console.log("complete");
                    });
            }

            //fills the user lists
            function fillUserLists() {
                //uses user array in closure variable
                //uses userSelectToUpdate select in closure variable
                returningUserSelect.html("");
                usBorrowingSelect.html("");
                usBorrowingFromSelect.html("");
                $.each(us, function (u, user) {
                    var myoptionReturn = $("<option></option>");
                    myoptionReturn.attr("id", "user_" + user.UserId);
                    myoptionReturn.html(user.FullName);
                    returningUserSelect.append(myoptionReturn);

                    var myoptionBorrower = $("<option></option>");
                    myoptionBorrower.attr("id", "user_borrow_" + user.UserId);
                    myoptionBorrower.html(user.FullName);
                    usBorrowingSelect.append(myoptionBorrower);

                    var myoptionLender = $("<option></option>");
                    myoptionLender.attr("id", "user_lend_" + user.UserId);
                    myoptionLender.html(user.FullName);
                    usBorrowingFromSelect.append(myoptionLender);
                });
                usBorrowingFromSelect.off("change");
                usBorrowingFromSelect.on("change", userChange);
                returningUserSelect.off("change");
                returningUserSelect.on("change", getBorrowedGamesByUser);
            }

            //fills return game list for selected borrower
            function fillGamesToReturnList() {
                //uses gamesBorrowed videogames array in closure variable
                //uses gamesBorrowed list in closure variable
                gamesBorrowed.html("");
                $.each(borrowedGamesByUser, function (g, game) {
                    var myLi = $("<option></option>");
                    myLi.attr("id", "game_" + game.VideoGameId);
                    //myLi.off("click");
                    myLi.on("click", selectBorrowedVideoGame);
                    myLi.html(game.Title);
                    gamesBorrowed.append(myLi);
                });
            }

            //fills the available game list for the selected owner
            function fillAvailableGamesList() {
                //uses gamesAvailable videogames array in closure variable
                //uses gamesAvailable list in closure variable
                gamesAvailable.html("");
                //alert(gamesAvailableByUser.length);
                $.each(gamesAvailableByUser, function (g, game) {
                    var myLi = $("<option></option>");
                    myLi.attr("id", "game_" + game.VideoGameId);
                    //myLi.off("click");
                    myLi.on("click", selectAvailableVideoGame);
                    myLi.html(game.Title);
                    gamesAvailable.append(myLi);
                });
            }

            
            function selectBorrowedVideoGame() {
                var vidId = this.id.substring(5);
                /*alert(vidId);*/
                selectedVideoGame = "none";
                $.each(gamesAvailableByUser, function (g, game) {
                    if (game.VideoGameId == vidId) {
                        selectedVideoGame = game;
                    }
                });

                if (selectBorrowedVideoGame != "none") {
                    $.ajax({
                        contentType: 'application/json',
                        url: "/api/videogame/" + vidId + "/return/",
                        type: 'PUT',
                        data: JSON.stringify(selectedVideoGame),
                        success: function (result) {
                            alert("success?");
                        },
                        error: (function (xhr) {
                            console.log("error: " + xhr.status);
                            alert("failure: " + xhr.status);
                        })
                    });
                }
            }

            function selectAvailableVideoGame() {
                var vidId = this.id.substring(5);
                /*alert(vidId);*/
                selectedVideoGame = "none";
                $.each(vidGamesOnPlat, function (g, game) {
                    if (game.VideoGameId == vidId) {
                        selectedVideoGame = game;
                    }
                });

                if (selectAvailableVideoGame != "none") {
                    $.ajax({
                        contentType: 'application/json',
                        url: "/api/videogame/" + vidId + "/borrow/",
                        type: 'PUT',
                        data: JSON.stringify(selectedVideoGame),
                        success: function (result) {
                            alert("success?");
                        },
                        error: (function (xhr) {
                            console.log("error: " + xhr.status);
                            alert("failure: " + xhr.status);
                        })
                    });
                }
            }

            function userChange() {
                var uId = $("#userBorrowingFrom").find(":selected").attr("id").substring(10);
                //alert("UID: " + uId);
                getGamesAvailableByUser(uId, fillAvailableGamesList);
            }

        }());

    </script>
</div>
